package com.muyu.client.mysql;


import com.muyu.client.basic.DataSourceConfig;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.utils.SpringUtils;
import com.muyu.common.data.base.BaseDataAbsSource;
import com.muyu.common.domain.DataSources;

import com.muyu.etl.domain.DataValue;
import com.muyu.etl.enums.DataType;



import com.zaxxer.hikari.HikariConfig;
import com.zaxxer.hikari.HikariDataSource;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.sql.*;
import java.util.concurrent.ConcurrentHashMap;


@Log4j2
@Component
public class MySqlDataSource extends BaseDataAbsSource {



    @Autowired
    private DataSourceConfig dataSourcesRemote;


    @Override
    public DataValue getDataValue() {

        return null;
    }

    @Override
    public DataValue[] getRow () {
//        MySqlQuery query = getQuery();
//        String sql = query.getSql();
//        Long dataSourceId = query.getDataSourceId();
//        ConcurrentHashMap<Integer, DataValue> map = new ConcurrentHashMap<>();
//
//        DataSources dataSources = dataSourcesService.getById(dataSourceId);
//
//        HikariConfig hikariConfig = new HikariConfig();
//        hikariConfig.setPoolName("HikariCP 连接池");
//        hikariConfig.setDriverClassName(dataSources.getDriverName());
//        hikariConfig.setJdbcUrl(dataSources.getUrl(dataSources)); // 修正这里
//        hikariConfig.setUsername(dataSources.getUserName());
//        hikariConfig.setPassword(dataSources.getUserPwd());
//        hikariConfig.setMinimumIdle(2);
//        hikariConfig.setMaximumPoolSize(10);
//
//        HikariDataSource hikariDataSource = new HikariDataSource(hikariConfig);
//
//        DataValue[] dataValues = null;
//
//        try {
//            PreparedStatement preparedStatement = conn.prepareStatement(sql);
//            ResultSet resultSet = preparedStatement.executeQuery();
//            ResultSetMetaData metaData = resultSet.getMetaData();
//            int columnCount = metaData.getColumnCount();
//            if (resultSet.next()){
//                for (int i = 1; i < columnCount; i++) {
//                    if (resultSet.isFirst()){
//                        String columnTypeName = metaData.getColumnTypeName(i);
//                        DatabaseMetaData metadataColumns = conn.getMetaData();
//                        ResultSet columns = metadataColumns.getColumns(null, null, metaData.getTableName(i), metaData.getColumnName(i));
//                        String remarks =null;
//                        while (columns.next()){
//                            remarks = columns.getString("REMARKS");
//                            log.info("字段备注:"+remarks);
//                        }
//                        DataValue build = DataValue.builder()
//                                .key(metaData.getColumnName(i))
//                                .label(remarks)
//                                .value(resultSet.getObject(i, DataType.convertType(columnTypeName)))
//                                .type(DataType.findBySqlType(columnTypeName))
//                                .build();
//                        map.put(i,build);
//                        dataValues[i-1]=build;
//                    }
//                }
//            }
//
//
//        } catch (SQLException e) {
//            throw new RuntimeException(e);
//        }
//        return dataValues;
        return null;
    }

    @Override
    public DataValue[][] getRows () {

        MySqlQuery query = getQuery();
        Integer one = Math.toIntExact(query.getOne());
        Integer two = query.getTwo();
        String sql = query.getSql();
        Long dataSourceId = query.getDataSourceId();
        ConcurrentHashMap<Integer, DataValue> map = new ConcurrentHashMap<>();

        DataSources dataSources = dataSourcesRemote.queryById(dataSourceId);

        HikariConfig hikariConfig = new HikariConfig();
        hikariConfig.setPoolName("HikariCP 连接池");
        hikariConfig.setDriverClassName(dataSources.getDriverName());
        hikariConfig.setJdbcUrl(dataSources.getUrl(dataSources)); // 修正这里
        hikariConfig.setUsername(dataSources.getUserName());
        hikariConfig.setPassword(dataSources.getUserPwd());
        hikariConfig.setMinimumIdle(2);
        hikariConfig.setMaximumPoolSize(10);

        DataValue[][] dataValues = new DataValue[one][two];

        HikariDataSource hikariDataSource = new HikariDataSource(hikariConfig);
        try {
            Connection conn = hikariDataSource.getConnection();
            PreparedStatement preparedStatement = conn.prepareStatement(sql);
            ResultSet resultSet = preparedStatement.executeQuery();
            ResultSetMetaData metaData = resultSet.getMetaData();
            int columnCount = metaData.getColumnCount();
            int c = 0;
            while (resultSet.next()){
                for (int i = 1; i <= columnCount; i++) {
                    if (resultSet.isFirst()){
                        String columnTypeName = metaData.getColumnTypeName(i);
                        DatabaseMetaData metaDataColumns = conn.getMetaData();
                        ResultSet columns = metaDataColumns.getColumns(null, null, metaData.getTableName(i), metaData.getColumnName(i));
                        String remarks =null;

                        while (columns.next()){
                            remarks = columns.getString("REMARKS");

                            log.info("字段备注:"+remarks);
                        }
                        DataValue build = DataValue.builder()
                                .key(metaData.getColumnName(i))
                                .label(remarks)
                                .value(resultSet.getObject(i, DataType.convertType(columnTypeName)))
                                .type(DataType.findBySqlType(columnTypeName))
                                .build();
                        map.put(i,build);
                        dataValues[c][i-1]=build;
                    }else {
                        DataValue build = DataValue.builder()
                                .key(metaData.getColumnName(i))
                                .label(map.get(i).getLabel())
                                .value(resultSet.getObject(i, map.get(i).getType().getTargetType()))
                                .type(map.get(i).getType())
                                .build();
                        dataValues[c][i-1]=build;
                    }
                }
                c++;
            }

        } catch (SQLException e) {
            throw new RuntimeException(e);
        }finally {
            close(hikariDataSource); // 关闭数据源
        }

        return dataValues;
    }
    private static void close(HikariDataSource dataSource) {
        if (dataSource != null) {
            dataSource.close();
        }
    }

}
