package com.muyu.common.domain;

import com.baomidou.mybatisplus.annotation.TableName;
import com.muyu.common.core.annotation.Excel;
import com.muyu.common.core.web.domain.BaseEntity;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

/**
 * @Author：zhangzhihao
 * @name：DictionaryData
 * @Date：2024/8/25 9:39
 * 不准抄代码，添加注释，清楚每一行代码意思
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@SuperBuilder
@EqualsAndHashCode(callSuper = true)
@TableName(value="dictionary_data")
public class DictionaryData extends BaseEntity {

    /**
     * id
     * */
    @Excel(name = "主键ID")
    private Long id;
    /**
     * 字典表id
     * */
    @Excel(name = "字典表ID")
    private Long dictionaryId;
    /**
     * 字典标签
     * */
    @Excel(name = "字典标签")
    private String label;
    /**
     * 字典值
     * */
    @Excel(name = "字典值")
    private String val;

    @Excel(name = "是否修改")
    private Boolean isEdit=false;

}
