package com.muyu.remote;

import com.muyu.common.core.domain.Result;
import com.muyu.common.domain.DataSources;
import com.muyu.etl.domain.DataValue;
import com.muyu.remote.factory.DataSourcesFactory;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;

/**
 * @author Administrator
 */
@EnableFeignClients
@FeignClient(value = "cloud-etl-datasources",fallbackFactory = DataSourcesFactory.class )
public interface DataSourcesRemote {
    @GetMapping("datasources/{id}")
    public Result<DataSources> queryById(@PathVariable("id") Long id);
}
