package com.muyu.datasources.controller;

import com.muyu.common.core.domain.Result;
import com.muyu.common.domain.Structure;
import com.muyu.datasources.service.StructureService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @Author：zhangzhihao
 * @name：StructureController
 * @Date：2024/8/26 20:43
 * 不准抄代码，添加注释，清楚每一行代码意思
 */
@RestController
@RequestMapping("structure")
public class StructureController {

    @Autowired
    private StructureService structureService;

    /**
     * 查询数据结构
     * @param id
     * @return
     */
    @GetMapping("/findStructureByTableId/{id}")
    public Result findStructureByTableId(@PathVariable("id") Long id){

        List<Structure> list = structureService.findStructureByTableId(id);

        return Result.success(list);
    }


}
