package com.muyu.datasources.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.muyu.common.domain.TableInfo;
import com.muyu.datasources.mapper.TableInfoMapper;
import com.muyu.datasources.service.TableInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Author：zhangzhihao
 * @name：TableInfoServiceImpl
 * @Date：2024/8/25 11:37
 * 不准抄代码，添加注释，清楚每一行代码意思
 */
@Service
public class TableInfoServiceImpl extends ServiceImpl<TableInfoMapper, TableInfo> implements TableInfoService {

    @Autowired
    private TableInfoMapper tableInfoMapper;


    @Override
    public TableInfo selectTableInfoByName(TableInfo tableInfoInsert) {

        LambdaQueryWrapper<TableInfo> tableInfoLambdaQueryWrapper = new LambdaQueryWrapper<>();


        tableInfoLambdaQueryWrapper.eq(TableInfo::getBasicId, tableInfoInsert.getBasicId())
                                    .eq(TableInfo::getTableName, tableInfoInsert.getTableName())
                                    .eq(TableInfo::getParentId, tableInfoInsert.getParentId());
        return this.tableInfoMapper.selectOne(tableInfoLambdaQueryWrapper);
    }

    @Override
    public List<Long> findTableIdByParentId(Long basicId) {
        return tableInfoMapper.findTableIdByParentId(basicId);
    }
}
